summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--debian/changelog19
-rwxr-xr-xscripts/build/lb_binary1
-rwxr-xr-xscripts/build/lb_binary_burg313
-rwxr-xr-xscripts/build/lb_binary_grub225
-rwxr-xr-xscripts/build/lb_binary_iso69
-rwxr-xr-xscripts/build/lb_config2
-rw-r--r--templates/burg/burg.cfg7
7 files changed, 435 insertions, 1 deletions
diff --git a/debian/changelog b/debian/changelog
index 23a1ffe..2e544de 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -1,3 +1,22 @@
+live-build (2.0.12+burg-4) unstable; urgency=low
+
+ * fixed wrong directory-paths.
+
+ -- Andreas Loibl <andreas@andreas-loibl.de> Fri, 25 Mar 2011 00:19:56 +0100
+
+live-build (2.0.12+burg-3) unstable; urgency=low
+
+ * Added ISO sorting.
+
+ -- Andreas Loibl <andreas@andreas-loibl.de> Thu, 24 Mar 2011 23:01:56 +0100
+
+live-build (2.0.12+burg-2) unstable; urgency=low
+
+ * Added burg support.
+ * Do not number the default kernel / initrd files.
+
+ -- Andreas Loibl <andreas@andreas-loibl.de> Thu, 24 Mar 2011 22:41:44 +0100
+
live-build (2.0.12-2) unstable; urgency=low
* Adding preinst script to remove
diff --git a/scripts/build/lb_binary b/scripts/build/lb_binary
index 27921f2..73b49d7 100755
--- a/scripts/build/lb_binary
+++ b/scripts/build/lb_binary
@@ -65,6 +65,7 @@ lb binary_debian-installer ${*}
lb binary_memtest ${*}
lb binary_grub ${*}
lb binary_grub2 ${*}
+lb binary_burg ${*}
lb binary_syslinux ${*}
lb binary_yaboot ${*}
lb binary_silo ${*}
diff --git a/scripts/build/lb_binary_burg b/scripts/build/lb_binary_burg
new file mode 100755
index 0000000..1bc16db
--- /dev/null
+++ b/scripts/build/lb_binary_burg
@@ -0,0 +1,313 @@
+#!/bin/sh
+
+## live-build(7) - System Build Scripts
+## Copyright (C) 2006-2011 Daniel Baumann <daniel@debian.org>
+##
+## live-build comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+## This is free software, and you are welcome to redistribute it
+## under certain conditions; see COPYING for details.
+
+
+set -e
+
+# Including common functions
+. "${LB_BASE:-/usr/share/live/build}"/scripts/build.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'installs burg into binary')"
+HELP=""
+USAGE="${PROGRAM} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+if [ "${LB_BOOTLOADER}" != "burg" ]
+then
+ exit 0
+fi
+
+Echo_message "Begin installing burg..."
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+# Checking stage file
+Check_stagefile .stage/binary_burg
+
+# Checking burg templates
+Check_templates burg
+
+# Checking lock file
+Check_lockfile .lock
+
+# Creating lock file
+Create_lockfile .lock
+
+# Check architecture
+Check_architecture amd64 i386
+Check_crossarchitecture
+
+# Checking depends
+Check_package chroot/usr/bin/burg-mkimage burg-pc
+
+# Restoring cache
+Restore_cache cache/packages_binary
+
+# Installing depends
+Install_package
+
+# Local functions
+Burg_live_entry ()
+{
+ LABEL="${1}"
+ KERNEL="${2}"
+ INITRD="${3}"
+ APPEND="${4}"
+
+ case "${LB_BINARY_IMAGES}" in
+ iso*|usb*)
+ if [ "${LABEL}" = "live" ]
+ then
+ # Do not number the default kernel / initrd files.
+ _NUMBER=""
+ else
+ # Use order of flavours in LB_LINUX_FLAVOURS for numbering.
+ _NUMBER="$(echo ${LB_LINUX_FLAVOURS} | awk -v FLAVOUR="${FLAVOUR}" 'BEGIN{RS=" "} {if($1 == FLAVOUR) print NR}')"
+ fi
+
+ if [ -e binary/${KERNEL} ]
+ then
+ mv binary/${KERNEL} "binary/$(dirname ${KERNEL})/vmlinuz${_NUMBER}"
+ KERNEL="$(dirname ${KERNEL})/vmlinuz${_NUMBER}"
+ fi
+
+ if [ -e binary/${INITRD} ]
+ then
+ mv binary/${INITRD} "binary/$(dirname ${INITRD})/initrd${_NUMBER}.img"
+ INITRD="$(dirname ${INITRD})/initrd${_NUMBER}.img"
+ fi
+ ;;
+ esac
+
+ LINUX_LIVE="${LINUX_LIVE}\nmenuentry \"Debian GNU/Linux - ${LABEL}\" {"
+ LINUX_LIVE="${LINUX_LIVE}\nlinux\t\t/${KERNEL} boot=${INITFS} config LB_BOOTAPPEND_LIVE ${APPEND}"
+ LINUX_LIVE="${LINUX_LIVE}\ninitrd\t\t/${INITRD}"
+ LINUX_LIVE="${LINUX_LIVE}\n}"
+}
+
+Burg_install_entry ()
+{
+ LABEL="${1}"
+ KERNEL="${2}"
+ INITRD="${3}"
+ APPEND="${4}"
+
+ if [ "${LABEL}" != "rescue" ] && [ "${LABEL}" != "rescuegui" ]
+ then
+ APPEND="${APPEND} quiet"
+ fi
+
+ LINUX_INSTALL="${LINUX_INSTALL}\nmenuentry \"Debian GNU/Linux - ${LABEL}\" {"
+ LINUX_INSTALL="${LINUX_INSTALL}\nlinux\t\t/${KERNEL} ${APPEND} LB_BOOTAPPEND_INSTALL"
+ LINUX_INSTALL="${LINUX_INSTALL}\ninitrd\t\t/${INITRD}"
+ LINUX_INSTALL="${LINUX_INSTALL}\n}"
+}
+
+case "${LB_INITRAMFS}" in
+ casper)
+ INITFS="casper"
+ ;;
+
+ live-initramfs|live-boot)
+ INITFS="live"
+ ;;
+esac
+
+# Setting destination directory
+case "${LB_BINARY_IMAGES}" in
+ iso*|tar)
+ case "${LB_INITRAMFS}" in
+ casper)
+ DESTDIR_LIVE="binary/casper"
+ ;;
+
+ live-initramfs|live-boot)
+ DESTDIR_LIVE="binary/live"
+ ;;
+ esac
+
+ DESTDIR_INSTALL="binary/install"
+ ;;
+
+ usb*|net)
+ Echo_warning "Bootloader in this image type not yet supported by live-build."
+ Echo_warning "This would produce a not bootable image, aborting (FIXME)."
+ exit 1
+ ;;
+esac
+
+Check_multiarchitecture
+
+# Creating directory
+mkdir -p "${DESTDIR_LIVE}"
+
+# Setting boot parameters
+
+case "${LB_ENCRYPTION}" in
+ ""|false)
+ ;;
+ *)
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} encryption=${LB_ENCRYPTION}"
+esac
+
+if [ -n "${LB_USERNAME}" ]
+then
+ case "${LB_INITRAMFS}" in
+ casper)
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} username=${LB_USERNAME}"
+ ;;
+
+ live-initramfs|live-boot)
+ if [ "${LB_USERNAME}" != "user" ]
+ then
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} username=${LB_USERNAME}"
+ fi
+ ;;
+ esac
+fi
+
+if [ -n "${LB_HOSTNAME}" ]
+then
+ case "${LB_INITRAMFS}" in
+ casper)
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} hostname=${LB_HOSTNAME}"
+ ;;
+
+ live-initramfs|live-boot)
+ if [ "${LB_HOSTNAME}" != "debian" ]
+ then
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} hostname=${LB_HOSTNAME}"
+ fi
+ ;;
+ esac
+fi
+
+if [ "${LB_UNION_FILESYSTEM}" != "aufs" ]
+then
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} union=${LB_UNION_FILESYSTEM}"
+fi
+
+if [ -n "${LB_NET_COW_PATH}" ]
+then
+ Echo_error "Net cow not yet supported on burg"
+ exit 1
+fi
+
+if [ "${LB_EXPOSED_ROOT}" != "false" ]
+then
+ LB_BOOTAPPEND_LIVE="${LB_BOOTAPPEND_LIVE} exposedroot"
+fi
+
+LB_BOOTAPPEND_LIVE="$(echo ${LB_BOOTAPPEND_LIVE} | sed -e 's| ||')"
+
+# Parameters are listed at: linux/Documentation/kernel-parameters.txt
+FAILSAFE="noapic noapm nodma nomce nolapic nomodeset nosmp vga=normal"
+
+# Assembling kernel configuration
+
+# Default entries
+DEFAULT_FLAVOUR="$(echo ${LB_LINUX_FLAVOURS} | awk '{ print $1 }')"
+DEFAULT_KERNEL="$(basename chroot/boot/vmlinuz-*${DEFAULT_FLAVOUR})"
+DEFAULT_INITRD="initrd.img-$(echo ${DEFAULT_KERNEL} | sed -e 's|vmlinuz-||')"
+
+Burg_live_entry "live" "$(basename ${DESTDIR_LIVE})/${DEFAULT_KERNEL}" "$(basename ${DESTDIR_LIVE})/${DEFAULT_INITRD}"
+Burg_live_entry "live (fail-safe mode)" "$(basename ${DESTDIR_LIVE})/${DEFAULT_KERNEL}" "$(basename ${DESTDIR_LIVE})/${DEFAULT_INITRD}" "${FAILSAFE}"
+
+for KERNEL in chroot/boot/vmlinuz-*
+do
+ VERSION="$(basename ${KERNEL} | sed -e 's|vmlinuz-||')"
+
+ Burg_live_entry "live, kernel ${VERSION}" "$(basename ${DESTDIR_LIVE})/$(basename ${KERNEL})" "$(basename ${DESTDIR_LIVE})/initrd.img-${VERSION}"
+ Burg_live_entry "live, kernel ${VERSION} (fail-safe mode)" "$(basename ${DESTDIR_LIVE})/$(basename ${KERNEL})" "$(basename ${DESTDIR_LIVE})/initrd.img-${VERSION}" "${FAILSAFE}"
+done
+
+LINUX_LIVE="$(/bin/echo ${LINUX_LIVE} | sed -e 's|binary||g' -e 's|//|/|g')"
+
+# Assembling debian-installer configuration
+if [ "${LB_DEBIAN_INSTALLER}" != "false" ]
+then
+ LINUX_LIVE="#\t \"Live\"\n${LINUX_LIVE}"
+ LINUX_INSTALL="#\t \"Installer\"\n"
+
+ VMLINUZ_DI="install/vmlinuz"
+ INITRD_DI="install/initrd.gz"
+ APPEND_DI="vga=normal"
+
+ VMLINUZ_GI="install/gtk/vmlinuz"
+ INITRD_GI="install/gtk/initrd.gz"
+ APPEND_GI="video=vesa:ywrap,mtrr vga=788"
+
+ Burg_install_entry "install" "${VMLINUZ_DI}" "${INITRD_DI}" "${APPEND_DI}"
+ Burg_install_entry "installgui" "${VMLINUZ_GI}" "${INITRD_GI}" "${APPEND_GI}"
+ Burg_install_entry "expert" "${VMLINUZ_DI}" "${INITRD_DI}" "priority=low ${APPEND_DI}"
+ Burg_install_entry "expertgui" "${VMLINUZ_GI}" "${INITRD_GI}" "priority=low ${APPEND_GI}"
+ Burg_install_entry "rescue" "${VMLINUZ_DI}" "${INITRD_DI}" "rescue/enable=true ${APPEND_DI}"
+ Burg_install_entry "rescuegui" "${VMLINUZ_GI}" "${INITRD_GI}" "rescue/enable=true ${APPEND_GI}"
+ Burg_install_entry "auto" "${VMLINUZ_DI}" "${INITRD_DI}" "auto=true priority=critical ${APPEND_DI}"
+ Burg_install_entry "autogui" "${VMLINUZ_GI}" "${INITRD_GI}" "auto=true priority=critical ${APPEND_GI}"
+fi
+
+LINUX_INSTALL="$(/bin/echo ${LINUX_INSTALL} | sed -e 's|binary||g' -e 's|//|/|g')"
+
+# Assembling memtest configuration
+if [ -f "${DESTDIR_LIVE}"/memtest ]
+then
+ MEMTEST="#\t \"Other\"\n"
+ MEMTEST="${MEMTEST}\nmenuentry\t\"${LB_MEMTEST}\" {\nlinux16\t$(basename ${DESTDIR_LIVE})/memtest\n}"
+ MEMTEST="$(/bin/echo ${MEMTEST} | sed -e 's|//|/|g')"
+fi
+
+# Copying templates
+mkdir -p binary/boot/burg
+cp -r "${TEMPLATES}"/* binary/boot/burg
+
+case ${LB_BINARY_IMAGES} in
+ iso*)
+ FILES="chroot/usr/lib/burg/i386-pc/*.mod chroot/usr/lib/burg/i386-pc/*.lst chroot/usr/lib/burg/i386-pc/efiemu??.o chroot/usr/share/burg/*.pf2"
+ ;;
+
+ usb*|tar)
+ FILES="chroot/usr/lib/burg/i386-pc/*"
+ ;;
+esac
+
+if [ "${LB_BUILD_WITH_CHROOT}" = "false" ]
+then
+ FILES="$(echo ${FILES} | sed -e 's|chroot||g')"
+fi
+
+# Copying burg
+cp ${FILES} binary/boot/burg
+
+# Copying local configuration file
+if [ -f config/binary_burg/burg.cfg ]
+then
+ cp config/binary_burg/burg.cfg binary/boot/burg/burg.cfg
+fi
+
+sed -i -e "s|LINUX_LIVE|${LINUX_LIVE}|" -e "s|LINUX_INSTALL|${LINUX_INSTALL}|" -e "s|MEMTEST|${MEMTEST}|" binary/boot/burg/burg.cfg
+sed -i -e "s|LB_BOOTAPPEND_INSTALL|${LB_BOOTAPPEND_INSTALL}|" -e "s|LB_BOOTAPPEND_LIVE|${LB_BOOTAPPEND_LIVE}|" binary/boot/burg/burg.cfg
+
+sed -i -e 's|\ $||g' binary/boot/burg/burg.cfg
+
+# Saving cache
+Save_cache cache/packages_binary
+
+# Removing depends
+Remove_package
+
+# Creating stage file
+Create_stagefile .stage/binary_burg
diff --git a/scripts/build/lb_binary_grub2 b/scripts/build/lb_binary_grub2
index 6ad8c3c..549274a 100755
--- a/scripts/build/lb_binary_grub2
+++ b/scripts/build/lb_binary_grub2
@@ -67,6 +67,31 @@ Grub_live_entry ()
INITRD="${3}"
APPEND="${4}"
+ case "${LB_BINARY_IMAGES}" in
+ iso*|usb*)
+ if [ "${LABEL}" = "live" ]
+ then
+ # Do not number the default kernel / initrd files.
+ _NUMBER=""
+ else
+ # Use order of flavours in LB_LINUX_FLAVOURS for numbering.
+ _NUMBER="$(echo ${LB_LINUX_FLAVOURS} | awk -v FLAVOUR="${FLAVOUR}" 'BEGIN{RS=" "} {if($1 == FLAVOUR) print NR}')"
+ fi
+
+ if [ -e binary/${KERNEL} ]
+ then
+ mv binary/${KERNEL} "binary/$(dirname ${KERNEL})/vmlinuz${_NUMBER}"
+ KERNEL="$(dirname ${KERNEL})/vmlinuz${_NUMBER}"
+ fi
+
+ if [ -e binary/${INITRD} ]
+ then
+ mv binary/${INITRD} "binary/$(dirname ${INITRD})/initrd${_NUMBER}.img"
+ INITRD="$(dirname ${INITRD})/initrd${_NUMBER}.img"
+ fi
+ ;;
+ esac
+
LINUX_LIVE="${LINUX_LIVE}\nmenuentry \"Debian GNU/Linux - ${LABEL}\" {"
LINUX_LIVE="${LINUX_LIVE}\nlinux\t\t/${KERNEL} boot=${INITFS} config LB_BOOTAPPEND_LIVE ${APPEND}"
LINUX_LIVE="${LINUX_LIVE}\ninitrd\t\t/${INITRD}"
diff --git a/scripts/build/lb_binary_iso b/scripts/build/lb_binary_iso
index 0394d36..7b6fe10 100755
--- a/scripts/build/lb_binary_iso
+++ b/scripts/build/lb_binary_iso
@@ -106,6 +106,21 @@ then
GENISOIMAGE_OPTIONS="${GENISOIMAGE_OPTIONS} -V \"${LB_ISO_VOLUME}\""
fi
+if [ -f config/binary_iso/isoimage.sort ]
+then
+ GENISOIMAGE_OPTIONS="${GENISOIMAGE_OPTIONS} -sort isoimage.sort"
+
+ case "${LB_BUILD_WITH_CHROOT}" in
+ true)
+ cp config/binary_iso/isoimage.sort chroot
+ ;;
+
+ false)
+ cp config/binary_iso/isoimage.sort .
+ ;;
+ esac
+fi
+
# Handle genisoimage architecture specific options
case "${LB_BOOTLOADER}" in
grub)
@@ -120,6 +135,12 @@ case "${LB_BOOTLOADER}" in
GENISOIMAGE_EXCLUDE="boot/grub/grub_eltorito"
;;
+ burg)
+ GENISOIMAGE_OPTIONS="${GENISOIMAGE_OPTIONS} -no-emul-boot -boot-load-size 4 -boot-info-table"
+ GENISOIMAGE_OPTIONS="${GENISOIMAGE_OPTIONS} -r -b boot/burg/burg_eltorito -J"
+ GENISOIMAGE_EXCLUDE="boot/burg/burg_eltorito"
+ ;;
+
silo)
GENISOIMAGE_OPTIONS="${GENISOIMAGE_OPTIONS} -r -G boot/isofs.b -B ..."
GENISOIMAGE_EXCLUDE="boot/isofs.b"
@@ -180,6 +201,11 @@ grub-mkimage -d \${input_dir} -o \${core_img} ${GRUB_MKIMAGE_OPTIONS} biosdisk i
# build grub_eltorito image
cat \${input_dir}/cdboot.img \${core_img} > binary/boot/grub/grub_eltorito
+if [ "${LB_BINARY_IMAGES}" = "iso-hybrid" ]; then
+ for i in \$(seq 64); do echo -n "ACRITOX!"; done > binary/boot.isohybrid
+ cat \${core_img} >> binary/boot.isohybrid
+fi
+
rm -f \${core_img}
for file in \${input_dir}/*.mod \${input_dir}/efiemu??.o \
@@ -193,6 +219,39 @@ do
done
EOF
+elif [ "${LB_BOOTLOADER}" = "burg" ]
+then
+
+cat > binary.sh << EOF
+#!/bin/sh
+
+input_dir=/usr/lib/burg/i386-pc
+
+# build core.img
+core_img=\$(mktemp)
+burg-mkimage -d \${input_dir} -o \${core_img} biosdisk iso9660
+
+# build burg_eltorito image
+cat \${input_dir}/cdboot.img \${core_img} > binary/boot/burg/burg_eltorito
+
+if [ "${LB_BINARY_IMAGES}" = "iso-hybrid" ]; then
+ for i in \$(seq 64); do echo -n "ACRITOX!"; done > binary/boot.isohybrid
+ cat \${core_img} >> binary/boot.isohybrid
+fi
+
+rm -f \${core_img}
+
+for file in \${input_dir}/*.mod \${input_dir}/efiemu??.o \
+ \${input_dir}/command.lst \${input_dir}/moddep.lst \${input_dir}/fs.lst \
+ \${input_dir}/handler.lst \${input_dir}/parttool.lst
+do
+ if test -f "\$file"
+ then
+ cp -f "\$file" binary/boot/burg
+ fi
+done
+EOF
+
else
echo "#!/bin/sh" > binary.sh
fi
@@ -205,10 +264,20 @@ EOF
if [ "${LB_BINARY_IMAGES}" = "iso-hybrid" ]
then
+case "${LB_BOOTLOADER}" in
+grub2|burg)
+cat >> binary.sh << EOF
+
+isohybrid-bg2 ${ISOHYBRID_OPTIONS} ${IMAGE}
+EOF
+;;
+syslinux)
cat >> binary.sh << EOF
isohybrid ${ISOHYBRID_OPTIONS} ${IMAGE}
EOF
+;;
+esac
fi
diff --git a/scripts/build/lb_config b/scripts/build/lb_config
index ac6beb0..afd9dca 100755
--- a/scripts/build/lb_config
+++ b/scripts/build/lb_config
@@ -44,7 +44,7 @@ USAGE="${PROGRAM} [--apt apt|aptitude]\n\
\t [--binary-indices true|false|none]\n\
\t [--bootappend-install PARAMETER|\"PARAMETERS\"]\n\
\t [--bootappend-live PARAMETER|\"PARAMETERS\"]\n\
-\t [--bootloader grub|syslinux|yaboot]\n\
+\t [--bootloader grub|grub2|burg|syslinux|yaboot]\n\
\t [--bootstrap cdebootstrap|cdebootstrap-static|debootstrap|copy]\n\
\t [--bootstrap-config FILE]\n\
\t [-f|--bootstrap-flavour minimal|standard]\n\
diff --git a/templates/burg/burg.cfg b/templates/burg/burg.cfg
new file mode 100644
index 0000000..957e465
--- /dev/null
+++ b/templates/burg/burg.cfg
@@ -0,0 +1,7 @@
+set default=0
+
+LINUX_LIVE
+
+LINUX_INSTALL
+
+MEMTEST